#include<vector>
#include<list>
#include<algorithm>
#include<cassert>
#include<numeric>
#include<iterator>
#include<iostream>

int main()
{
  std::vector<int> V(5);
  for(int i = 0;i<V.size();i++)
  {
    V.at(i)=i;
  }
  
  std::list<int> L(V.size());
  std::copy(V.begin(), V.end(), L.begin());
  assert(std::equal(V.begin(), V.end(), L.begin()));

  std::cout<<"Vector: "<<std::endl<<"|";
  std::copy(V.begin(),V.end(),std::ostream_iterator<int>(std::cout, "|"));

  std::cout<<std::endl<<"List: "<<std::endl<<"|";
  std::copy(L.begin(),L.end(),std::ostream_iterator<int>(std::cout, "|"));
  std::cout<<std::endl;
  
  return 0;
}
