#include <boost/spirit/include/qi.hpp>
#include <boost/spirit/include/phoenix_core.hpp>
#include <boost/spirit/include/phoenix_operator.hpp>
#include <boost/foreach.hpp>

namespace qi = boost::spirit::qi;
namespace ascii = boost::spirit::ascii;

template<typename Iterator>
bool parse_numbers(Iterator first, Iterator last)
{
  using qi::double_;
  using qi::phrase_parse;
  using boost::spirit::_1;
  using ascii::space;
  using boost::phoenix::ref;

  double sum=0;
  std::vector<double> fill;

    bool r = phrase_parse(
        first,                       
        last,                        
        (double_[ref(sum)+=_1] % ','),space,fill
    );
    std::cout<<sum<<std::endl;
    BOOST_FOREACH(const double& d, fill){
      std::cout<<d<<std::endl;
    }
    if (first != last) // fail if we did not get a full match
        return false;
    return r;
}

int main()
{
  const std::string double_string("2.4,7.4,11.234,1111.2222");
  bool stat = parse_numbers(double_string.begin(),double_string.end());
  std::cout<<stat<<std::endl;
  return 0;
}
